      subroutine wlam
c Integrate to get lambda,lamh11,lamh20,lamh21,lamh31
        integer steps
	logical undef
        real inorm
        double precision wron,s2rw
        real zdl(1000),tdl(1000),ttdl(1000),s2bdl(1000),bfdl(1000),
     & pwtdl(1000),psqidl(1000),pdwt(1000),pdidl(1000),qkv(1000),
     & qkvsq(1000)
        real dlama1(1000),dlama2(1000),dlama3(1000),dkvsq(1000)
     & ,dtt(1000),dnupsq(1000),dkhl(1000)
        real lambda,lamphi,lmphsq,logphi,lvsave
        real lambd,lambdl
        real b12(900),a1b2(900),a2b1(900)
         real lp,lv,musq,lvinsq,n,pi,n0b
      real kv,kvsq,nusq,nu,nupsq,lamba1,lamba2,lamba3,lamh10,lamh11,
     *lambh1,lamh20,lamh21,lambh2,lamh30,lamh31,lambh3,nuprim
      real a1nsq,a2nsq,b1nsq(900),b2nsq(900),ab1n(900),ab2n(900),
     & sa1n(900),sa2n(900),sb1n(900),sb2n(900),sc1n(900),sc2n(900)
	common/iounit/iuinp,iuout
        common/parm/q0,q0inv,q0sq,range,n0b,wi,winv
	common/kv/kvsq,kv
      common/valid/a1phsq,lamba1,a2nusq,lamba2,a3kvsq,lamba3,lamh10,
     *lamh11,lambh1,lamh20,lamh21,lambh2,lamh30,lamh31,lambh3
      common/rayst/zdl,tdl,ttdl,s2bdl,bfdl,pwtdl,psqidl,pdwt,pdidl
     *,qkv,qkvsq
      common/const/pi
      common/ray/zlas,z,tlas,t,s2las,t2las,ttlas,tt,pslas,ps,pdlas,pd,
     & undef
      common/ab/a1nsq,a2nsq,b1nsq,b2nsq,ab1n,ab2n,sa1n,sa2n,sb1n,
     & sb2n,sc1n,sc2n
      common/lphi/phisq,phi,logphi,lambda,lamphi,lmphsq
      common/rayst2/dlama1,dlama2,dlama3,dkvsq,dtt,dnupsq,dkhl
      common/rparm/rmax,steps,hstore,hlas
      common/loops/nloops,itmin,rfrac
      common/ta1/sa12,sb12,sab12,sa12n,sb12n,sab12n
      common/sr/s1r,s2r,wron,s2rw
      common/ab12/a12,b12,a1b2,a2b1
      common/depthf/depth
c
       loc=rfrac/hstore+1
       s1rsq=s1r*s1r
         lambda=0.
         lambd=0.
         lambdl=0.
         dlh1=0.
         dlh2=0.
         dlh20=0.
         dlh3=0.
         dlh1l=0.
         dlh2l=0.
         dlh20l=0.
         dlh3l=0.
         alm=2.0*pi*q0inv
         if(nloops.eq.0) go to 35
         do 30 j=1,nloops
         do 10 i=1,steps-2
          tu1=a12*(s2bdl(i)**2)+b12(j)*(tdl(i)**2)+
     &  (a1b2(j)+a2b1(j))*s2bdl(i)*tdl(i)
          tu1=abs(tu1*s1r)
          dtu1=tu1*dkvsq(i)
          lambd=lambd+dtu1
        depthz=zdl(i)+sqrt(tu1*alm)
        depth=depthz
        call sspeed(depthz,c,dc,d2ur,undef)
        call bvfreq(depthz,n,undef)
        t=tdl(i)
        dcf=dc
        if(depthz.lt.0.) dcf=-dc
        call fluct(n,c,dcf,t,musq,lp,lv,undef)
        lvinsq=1./(lv*lv)
        dlh1=dlh1+musq*lp
        wl=sqrt(wi*wi+n*n*t*t)
        inorm=w0avg(wi,wl,n)
        wsq=wl*wl
        if(inorm.gt.0) wsq=w2avg(wi,wl,n)/inorm
        dlh2=dlh2+musq*lp*wsq
        dlh20=dlh20+pdwt(i)
        s1xsq=a1nsq*(s2bdl(i)**2)+b1nsq(j)*(tdl(i)**2)+
     & 2.*ab1n(j)*s2bdl(i)*tdl(i)
        dlh3=dlh3+musq*lp*s1xsq*lvinsq
10       continue
         i=steps-1
          tu1=a12*(s2bdl(i)**2)+b12(j)*(tdl(i)**2)+
     &  (a1b2(j)+a2b1(j))*s2bdl(i)*tdl(i)
          tu1=abs(tu1*s1r)
          dtu1=tu1*dkvsq(i)
          lambdl=lambdl+dtu1
        depthz=zdl(i)+sqrt(tu1*alm)
        depth=depthz
        call sspeed(depthz,c,dc,d2ur,undef)
        call bvfreq(depthz,n,undef)
        t=tdl(i)
        dcf=dc
        if(depthz.lt.0.) dcf=-dc
        call fluct(n,c,dcf,t,musq,lp,lv,undef)
        dlh1l=dlh1l+musq*lp
        wl=sqrt(wi*wi+n*n*t*t)
        inorm=w0avg(wi,wl,n)
        wsq=wl*wl
        if(inorm.gt.0) wsq=w2avg(wi,wl,n)/inorm
        dlh2l=dlh2l+musq*lp*wsq
        dlh20l=dlh20l+pdwt(i)
        s1xsq=a1nsq*(s2bdl(i)**2)+b1nsq(j)*(tdl(i)**2)+
     & 2.*ab1n(j)*s2bdl(i)*tdl(i)
        lvinsq=1./(lv*lv)
        dlh3l=dlh3l+musq*lp*s1xsq*lvinsq
30       continue
35         j=nloops+1
          do 40 i=1,loc
          tu1=a12*(s2bdl(i)**2)+b12(j)*(tdl(i)**2)+
     &  (a1b2(j)+a2b1(j))*s2bdl(i)*tdl(i)
          tu1=abs(tu1*s1r)
          dtu1=tu1*dkvsq(i)
        depthz=zdl(i)+sqrt(tu1*alm)
        depth=depthz
        call sspeed(depthz,c,dc,d2ur,undef)
        call bvfreq(depthz,n,undef)
        t=tdl(i)
        dcf=dc
        if(depthz.lt.0.) dcf=-dc
        call fluct(n,c,dcf,t,musq,lp,lv,undef)
        wl=sqrt(wi*wi+n*n*t*t)
        inorm=w0avg(wi,wl,n)
        wsq=wl*wl
        if(inorm.gt.0) wsq=w2avg(wi,wl,n)/inorm
        s1xsq=a1nsq*(s2bdl(i)**2)+b1nsq(j)*(tdl(i)**2)+
     & 2.*ab1n(j)*s2bdl(i)*tdl(i)
        lvinsq=1./(lv*lv)
        if(i.eq.loc) go to 40
        lambda=lambda+dtu1
        dlh1=dlh1+musq*lp
        dlh2=dlh2+musq*lp*wsq
        dlh20=dlh20+pdwt(i)
        dlh3=dlh3+musq*lp*s1xsq*lvinsq
40      continue
        hfrac=rfrac-hstore*(loc-1)
        if(rfrac.le.hstore) hfrac=rfrac
          lambda=(lambda+lambd)*hstore+lambdl*hlas
     &  +dtu1*hfrac
          lambh1=dlh1*hstore+dlh1l*hlas
     &  +musq*lp*hfrac
          lambh2=dlh2*hstore+dlh2l*hlas
     &  +musq*lp*wsq*hfrac
          lamh20=dlh20*hstore+dlh20l*hlas
     &  +pdwt(loc)*hfrac
          lambh3=(dlh3*hstore+dlh3l*hlas
     &  +musq*lp*s1xsq*lvinsq*hfrac)*s1rsq
3         format (1x,10e12.4)
          return
          end
