       subroutine lphir
c do integrals to obtain lambda and phi
c
       character*20 raytyp
       logical ylong,yfluct,yray2
       real lambda,lamphi,lmphsq,logphi,lvsave
       real n0b
c
      common/lphi/phisq,phi,logphi,lambda,lamphi,lmphsq
      common/iounit/iuinp,iuout
      common/parm/q0,q0inv,q0sq,range,n0b,wi,winv
      common/lvsave/lvsave,time
      common/option/yfluct,ylong,yray2
c
       call wphsqs
      phisq =phisq*q0sq
      phi=sqrt(phisq)
      call wlam
      lambda = q0*lambda/phisq
      lmphsq = phisq*lambda
      lamphi= phi*lambda
      logphi=alog(phi)
      if (logphi.lt.1.) logphi=1.
      if(ylong) then
         if(lamphi.ge.(1.).and.phi.ge.(1.)) then 
            raytyp='fully saturated'
         else if(lmphsq.ge.1.) then
               raytyp='partially saturated'
            else 
               raytyp='unsaturated'
            endif
         write(iuout,100)
 100  format('WAVE PROPAGATION REGION'/)
         write(iuout,101) raytyp
 101  format(' This ray is tentatively identified as being        ',20a)
         write(iuout,103)phi,lambda,lamphi,lmphsq,logphi
 103  format(
     *'phi        =  ',g12.5,'   lambda            = ',g12.5,/,
     *'lambda phi =  ',g12.5,'   lambda phi square = ',g12.5,/,
     *'ln(phi)    =  ',g12.5/)
         write(iuout,104) lamphi*lvsave
 104  format(' The micropaths are spread over a ',/,
     *'vertical distance (lambda phi Lv) of      ',g12.5,' m')
         write(iuout,105) lmphsq
 105  format(' The approximate number of micropaths or the rms phase dif
     *ference'/'between one micropath and another (lambda phi square) is
     *',g12.5/)
      endif
      return
      end
