      subroutine wkhsqs
c
c calculates horizontal coherence length kh 
      integer steps,hcount
      logical nofloq
      real dlama1(1000),dlama2(1000),dlama3(1000),dkvsq(1000),dtt(1000)
     *  ,dnupsq(1000),dkhl(1000),lat
      common/rayst2/dlama1,dlama2,dlama3,dkvsq,dtt,dnupsq,dkhl
      real zdl(1000),tdl(1000),ttdl(1000),s2bdl(1000),bfdl(1000),
     *  pwtdl(1000),psqidl(1000),pdwt(1000),pdidl(1000),
     *  qkv(1000),qkvsq(1000)
      common/rayst/zdl,tdl,ttdl,s2bdl,bfdl,pwtdl,psqidl,pdwt,pdidl,
     &  qkv,qkvsq
      common/mpparm/sdepth,angle,h,hcount,rfinal,rdepth,freq,lat,
     &  nofloq
      common/horiz/hseps,hsepr,wkhsq
      common/rparm/rmax,steps,hstore,hlas
      common/loops/nloops,itmin,rfrac
      loc=rfrac/hstore+1
c
c These are a whole bunch of diagnostics I added whenI was trying to 
c to compute horizontal coherence length. Horiztonal coherence length
c per se is not output in the standard output file, so I had to 
c emit it separately (from spacsc.f) These diagnostics below are not
c necessary for routine calculations. RKA 20120918
c     print*,'wkhsqs:'
c     print*,'hseps=',hseps,' hsepr=',hsepr
c     print*,'rmax=',rmax,'steps=',steps
c     print*,'hstore=',hstore,'hlas=',hlas
c     print*,'nloops = ',nloops
c     print*,'rfrac=',rfrac 
c     print*,'loc=',loc
c
      hseprs=hsepr-hseps
      wkhsq=0.
      wkhsql=0.
      x=0.
      if(nloops.eq.0) go to 35
c
      do 25 j=1,nloops
         do 20 i=1,steps-2
             hlsq=dkhl(i)**2
             dy=hseps+hseprs*x/rfinal
             dys=dy*dy
             dyshl=dys+hlsq
             pwt=pwtdl(i)
             fh=(dys/dyshl)**0.75
             wkhsq=wkhsq+pwt*fh
             x=x+hstore
20       continue
         i=steps-1
         hlsq=dkhl(i)**2
         dy=hseps+hseprs*x/rfinal
         dys=dy*dy
         dyshl=dys+hlsq
         pwt=pwtdl(i)
         fh=(dys/dyshl)**0.75
         wkhsql=wkhsql+pwt*fh
         x=x+hlas
25    continue
35    do 40 i=1,loc-1
          hlsq=dkhl(i)**2
          dy=hseps+hseprs*x/rfinal
          dys=dy*dy
          dyshl=dys+hlsq
          pwt=pwtdl(i)
          fh=(dys/dyshl)**0.75
          if(i.eq.loc-1) go to 40
          wkhsq=wkhsq+pwt*fh
          x=x+hstore
40    continue
      wkhsq=wkhsq*hstore+wkhsql*hlas+pwt*fh*(rfrac-hstore*(loc-1))
      return
      end
