      subroutine wkvsq
c
c integrate this to get kv squared 
c kv is vertical coherence length
          double precision s2rw,wron
        integer steps,hcount
        real zdl(1000),tdl(1000),ttdl(1000),s2bdl(1000),bfdl(1000),
     & pwtdl(1000),psqidl(1000),pdwt(1000),pdidl(1000),qkv(1000),
     & qkvsq(1000)
        real dlama1(1000),dlama2(1000),dlama3(1000),dkvsq(1000)
     & ,dtt(1000),dnupsq(1000),dkhl(1000)
        real kv,kvsq
        real a1nsq,a2nsq,b1nsq(900),b2nsq(900),ab1n(900),ab2n(900),
     & sa1n(900),sa2n(900),sb1n(900),sb2n(900),sc1n(900),sc2n(900)
      real lamba1,lamba2,lamba3,lamh10,lamh11
     *,lambh1,lamh20,lamh21,lambh2,lamh30,lamh31,lambh3
      common/loops/nloops,itmin,rfrac
      common/valid/a1phsq,lamba1,a2nusq,lamba2,a3kvsq,lamba3,lamh10,
     *lamh11,lambh1,lamh20,lamh21,lambh2,lamh30,lamh31,lambh3
	common/iounit/iuinp,iuout
        common/kv/kvsq,kv
      common/rayst/zdl,tdl,ttdl,s2bdl,bfdl,pwtdl,psqidl,pdwt,pdidl,
     & qkv,qkvsq
      common/rparm/rmax,steps,hstore,hlas
      common/rayst2/dlama1,dlama2,dlama3,dkvsq,dtt,dnupsq,dkhl
c
      common/ab/a1nsq,a2nsq,b1nsq,b2nsq,ab1n,ab2n,sa1n,sa2n,
     & sb1n,sb2n,sc1n,sc2n
c
c          xisq = (s1x*s1x)*wron*wron
c          wkvsq=terp(dkvsq,x)* xisq
          wkvs=0.0
          zlamb3=0.0
          loc=rfrac/hstore+1
          nl=nloops+1
          nl1=nloops+2
       if(loc.eq.1) go to 22
       do 20 i=1,loc-1
       wkv=(sa1n(nl1)*s2bdl(i)**2+
     & sb1n(nl1)*tdl(i)**2+
     & 2.*sc1n(nl1)*s2bdl(i)*tdl(i))
       wkvs=wkvs+wkv*dkvsq(i)
       zlamb3=zlamb3+wkv*dlama3(i)
       wkv=0.0
20     continue
22       i=loc
       wkv=(a1nsq*s2bdl(i)**2+b1nsq(nl)*tdl(i)**2+2.*ab1n(nl)
     & *s2bdl(i)*tdl(i))
       wkvlas=wkv*dkvsq(i)*(rfrac-hstore*(loc-1))
       zl3las=wkv*dlama3(loc)*(rfrac-hstore*(loc-1))
       wkv=0.0
       if(loc.gt.steps-2) go to 33
       if(nloops.eq.0) go to 35
       do 30 i=loc,steps-2
       wkv=(sa1n(nl)*s2bdl(i)**2+sb1n(nl)*tdl(i)**2+2.*sc1n(nl)
     & *s2bdl(i)*tdl(i))
       wkvs=wkvs+wkv*dkvsq(i)
       zlamb3=zlamb3+wkv*dlama3(i)
30     continue
33       wkv=(sa1n(nl)*s2bdl(steps-1)**2+sb1n(nl)*tdl(steps-1)**2
     &  +2.*sc1n(nl)*s2bdl(steps-1)*tdl(steps-1))
35       kvsq=wkvs*hstore+wkv*dkvsq(steps-1)*hlas
     & + wkvlas
       lamba3=zlamb3*hstore+wkv*dlama3(steps-1)*hlas
     & + zl3las
c        print *,'kvsq=',kvsq
          return
          end
