      subroutine zstep
c step ray along
c added small steps dxl for r,t2,s2 calculations at turn.point.oct31.94.glr
      logical yfluct,ylong,yray2
      real lat,n0b,mj,n,musq,lp,lv,inorm,lvinsq,le,lp2,leqlv,lhz
          integer step,steps,hcount	
      logical undef,error,nofloq
      real na,jstar,msqmax,njinv
          real zdl(1000),tdl(1000),ttdl(1000),s2bdl(1000),bfdl(1000),
     *pwtdl(1000),psqidl(1000),pdwt(1000),pdidl(1000),
     *qkv(1000),qkvsq(1000)
      common/mpparm/sdepth,angle,h,hcount,rfinal,rdepth,freq,lat,nofloq
          common/parm/q0,q0inv,q0sq,range,n0b,wi,winv
          common/rparm/rmax,steps,hstore,hlas
      common/rayst/zdl,tdl,ttdl,s2bdl,bfdl,pwtdl,psqidl,pdwt,pdidl
     *,qkv,qkvsq
      real dlama1(1000),dlama2(1000),dlama3(1000),dkvsq(1000),dtt(1000)
     *,dnupsq(1000),dkhl(1000)
          common/rayst2/dlama1,dlama2,dlama3,dkvsq,dtt,dnupsq,dkhl
          common/flparm/na,jstar,zeta,gamad,msqmax,mj,njinv,avj
          common/stepb/dx,step
      common/ray/zlas,z,tlas,t,s2las,t2las,ttlas,tt,pslas,ps,pdlas,pd,
     *undef
          common/speed/c,dc,d2ur
          common/rtube/s2,t2
c
          common/sext/zx0,up0,rdpi,rdpinv
c
          common/coef/csz,dxl,dx2,dx3,dx2l,dx3l,dt,ttf
          common/option/yfluct,ylong,yray2
          common/depthf/depth
c depth to use in fluctc to calculate  musq,n dc/c from canonical profile
c formula with given b,epsilon,c0.z0
           save
c 
          data toler,lsteps/0.06,5/
          data lhz/12000./
c
c     'zdl' ... ray depth
c     'tdl' ... tangent of ray angle
c
          undef=.false.
          zlas=z
          tlas=t
          s2las=s2
          t2las=t2
          ttlas=tt
          pslas=ps
          pdlas=pd
          if (abs(t).lt.toler) go to 15
c changed Nov.16,1993.glr
          if(yray2) then
          z=z-t*dx+(t*d2ur*dx3-(dc/c)*dx2)*(1.0+t*t)
          else
          z=z-t*(dx-d2ur*dx3)-(dc/c)*dx2
          endif
          call sspeed(z,c,dc,d2ur,undef)
c          if (undef) go to 300
          x=csz*c
          if (abs(x).gt.1..or.undef) go to 10
          t=sign(sqrt(1.-x*x)/x,t)
          r=-dx*d2ur*s2
c changed Nov.16,1993.glr
          if(yray2) r=r-dx*d2ur*s2*t*t-(dc/c)*2.0*t*t2*dx
          s2=s2+t2*dx
          t2=r+t2
          go to 30
c
c     the ray is near a turning point:
c        the angle is small or
c        the attempt to take a full step was unsucessful
c
   10     z=zlas
          undef=.false.
          call sspeed(z,c,dc,d2ur,undef)
          if (undef) go to 300
15        if(yray2) then
          do 20 i=1,lsteps
          z=z-t*dxl+(t*d2ur*dx3l-(dc/c)*dx2l)*(1.0+t*t)
          t=t+(t*d2ur*dx2l+(dc/c)*dxl)*(1.0+t*t)
          call sspeed(z,c,dc,d2ur,undef)
          if (undef) go to 300
c changed Nov.16,1993.glr
          r=-dxl*d2ur*s2*(1.0+t*t)-(dc/c)*2.0*t*t2*dxl
          s2=s2+t2*dxl
          t2=r+t2
   20     continue
          else
          do 22 i=1,lsteps
          z=z-t*(dxl-d2ur*dx3l)-(dc/c)*dx2l
          t=t*(1.+d2ur*dx2l)+(dc/c)*dxl
          call sspeed(z,c,dc,d2ur,undef)
          if (undef) go to 300
          r=-dxl*d2ur*s2
          s2=s2+t2*dxl
          t2=r+t2
   22     continue
          endif
   30     continue
          undef=.false.
          call bvfreq(z,n,undef)
          if (undef) go to 320
          dcf=dc
          if (z.lt.0.) dcf=-dc
          depth = z
          call fluct(n,c,dcf,t,musq,lp,lv,undef)
          if (undef) go to 340 
c
c          if(musq.le.0.) then
c          print *,z,n,musq
c          endif
          pwt=musq*lp
c          adu = abs(dc/c)
c          lp2=lp*1.1
c          if (adu.gt.0.) lp2 = sqrt(2.*lv/adu)
c          le=amin1(lp,lp2)
c lp correction le= removed 11.17.96glr
           le=lp
c addition 12/90
          pwt=musq*le
c to check difference
          wl=sqrt(wi*wi+n*n*t*t)
          inorm=w0avg(wi,wl,n)
          pdw=wl*wl
          if (inorm.le.0.) go to 100
          pdw=w2avg(wi,wl,n)/inorm
  100     pdw=pwt*pdw
          lvinsq = 1./(lv*lv)
          leqlv = le * q0inv * lvinsq
          dlma1 = pwt * leqlv
          dlma2 = pdw * leqlv
          dlma3 = dlma1 * lvinsq 
          dt = 1./(c*c)
          dksq = pwt * lvinsq
          dnups = pdw * lvinsq
          dhl=lhz*wi/wl
          return
c
      entry zstore
          zdl(step)=z
          tdl(step)=t
          bfdl(step)=n
          s2bdl(step)=s2
c pwt is the unintegrated  phi squared
          pwtdl(step)=pwt
c pdwt is the unintegrated phi dot squared
          pdwt(step)=pdw
          qkk=1./(lv*smj)
          qkv(step)=qkk*q0inv
          qkvsq(step)=qkk*qkk*q0inv
          dtt(step) = ttf * dt
          dlama1(step) = dlma1
          dlama2(step) = dlma2
          dlama3(step) = dlma3
          dkvsq(step) = dksq
          dkhl(step) = dhl
          dnupsq(step) = dnups
          return 
      entry zinit
          undef=.false.
c find the sound speed and derivatives at the source depth
          call sspeed(z,c,dc,d2ur,undef)
          if (undef) go to 300 
c find the buoyancy frequency at the source depth
          call bvfreq(z,n,undef)
          if (undef) go to 320
          dcf=dc
c change the sign if the ray is surface-reflected
          if (z.lt.0.) dcf=-dc
          depth = z
c find the fluctuation parameters at the source depth
          call fluct(n,c,dcf,t,musq,lp,lv,undef)
          if (undef) go to 340 
          csz=cos(atan(t))/c
          zdl(step)=z
          tdl(step)=t
          zx0 = t
          up0 = -dc/c
c          print *,'in zstep,z,t,zx0,up0',z,t,zx0,up0
          s2= up0*rdpi
	s2bdl(step) = s2
          t2= zx0*rdpinv - dx*d2ur*s2*(0.5)
c         t2= zx0*rdpinv
c          print *,'in zstep,s2,t2',s2,t2
          tt=0.
          dt = 1/(c*c)
          ttf=c/cos(atan(t))
          dtt(step) = ttf * dt
          bfdl(step)=n
c  change 12/90
c          lp2=lp*1.1
c          adu=abs(dc/c)
c          if (adu.gt.0.) lp2 = sqrt(2.*lv/adu)
c          le=amin1(lp,lp2)
c lp correction 'le=' removed 11.17.96glr
          le=lp
          pwt=musq*le
c
          pwtdl(step)=pwt
          wl=sqrt(wi*wi+n*n*t*t)
          inorm=w0avg(wi,wl,n)
          pdw=wl*wl
          if (inorm.le.0) go to 99
          pdw=w2avg(wi,wl,n)/inorm
99        pdw=pwt*pdw
          pdwt(step)=pdw
          smj=sqrt(mj)
          qkk=1./(smj*lv)
          qkv(step)=qkk*q0inv
          qkvsq(step)=qkk*qkk*q0inv
          lvinsq = 1./(lv*lv)
          dksq = pwt * lvinsq
          dhl = lhz*wi/wl
          leqlv = le * q0inv * lvinsq
          dnups = pdw * lvinsq
          dkvsq(step) = dksq
          dkhl(step) = dhl
          dlma1 = pwt * leqlv
          dlama1(step) = dlma1
          dlma2 = pdw * leqlv
          dlama2(step) = dlma2
          dlma3 = dlma1 * lvinsq
          dlama3(step) = dlma3
          dnupsq(step) = dnups
c
      entry zindx
          dx2=dx*dx/2.
          dx3=dx*dx2/3.
          dxl=dx/float(lsteps)
          dx2l=dxl*dxl/2.
          dx3l=dx*dx2l/3.
          if(step.gt.2) go to 804
 804	continue
          return
  300     error=.true.
          if(ylong) call dlaerr(1,range,z,t)
          return
  320     error=.true.
          if(ylong) call dlaerr(3,range,z,t)
          return
  340     error=.true.
          if(ylong) call dlaerr(5,range,z,t)
          return
          end
