	subroutine path
c Calculate validity of path integral.
c The flag variable is used by the functions to be integrated 
c to tell it whether the function is to evaluated on the ray(flag = 0)
c or off the ray(flag =1)
c
      logical ylong,yfluct,yray2
      real kv,kvsq,nusq,nu,nupsq,lamba1,lamba2,lamba3,lamh10,lamh11
     *,lambh1,lamh20,lamh21,lambh2,lamh30,lamh31,lambh3,nuprim
     *,logphi,n0b,lmphsq,lambda,lamphi
       double precision wron,s2rw
	common/iounit/iuinp,iuout
      common/loops/nloops,itmin,rfrac
      common/valid/a1phsq,lamba1,a2nusq,lamba2,a3kvsq,lamba3,lamh10,
     *lamh11,lambh1,lamh20,lamh21,lambh2,lamh30,lamh31,lambh3
        common/parm/q0,q0inv,q0sq,range,n0b,wi,winv
	common/lphi/phisq,phi,logphi,lambda,lamphi,lmphsq
	common/nu/nusq,nu,nupsq,nuprim,phovnu
	common/tau/tau1,tau0sq,tau0
        common/sr/s1r,s2r,wron,s2rw
	common/kv/kvsq,kv
        common/option/yfluct,ylong,yray2
c
      call wlmao
      a1phsq = q0sq * lamba1
      lamba1 = a1phsq / phisq
      a2nusq =  q0sq * lamba2
      lamba2 =  a2nusq / nusq
      a3kvsq  = q0sq * lamba3 
      lamba3 = a3kvsq / kvsq
      lamba3 = lamba3 * logphi
      lamh10 = phisq 
      lambh1 = lambh1*q0sq 
      lambh1 = (lambh1 - lamh10)/lamh10
      lamh20 = lamh20*q0sq
      lambh2=lambh2*q0sq
      lambh2 = (lambh2 - lamh20)/lamh20
      lamh30 = (kvsq/logphi)*s1r*s1r 
      lambh3=lambh3*q0sq
      lambh3 = (lambh3 - lamh30)/lamh30
      if(ylong) then
      write(iuout,106)
 106  format('VALIDITY OF PATH INTEGRAL'/)
      write(iuout,107)lamba1,lambh1,lamba2,lambh2,lamba3,lambh3
 107  format('The following parameters should be less than unity '/'for
     * validity of the appropriate path-integral formulas:',/,
     *'                             ANISOTROPY          INHOMOGENEITY '/
     *'phi                           ',g12.5,10x,g12.5,/
     *'second moment (time)          ',g12.5,10x,g12.5,/,
     *'second moment (vert. separ.)  ',g12.5,10x,g12.5,/)
      endif
	return
	end
