      subroutine rayini(error)
c
c 
        integer hcount,timeit
        integer steps
        double precision wron,s2rw
      logical nofloq,error,undef
      logical ylong,yfluct,yray2
      logical reflct
      real lat,n0b,lvsave,msapx,lpapx,lvapx,kvsq,kv
      real zdl(1000),tdl(1000),ttdl(1000),s2bdl(1000),bfdl(1000),
     *pwtdl(1000),psqidl(1000),pdwt(1000),pdidl(1000),qkv(1000),
     *qkvsq(1000)
        character*10 itime,idate
c
        common/rayst/zdl,tdl,ttdl,s2bdl,bfdl,pwtdl,psqidl,pdwt,pdidl
     *,qkv,qkvsq
        common/iounit/iuinp,iuout
      common/mpparm/sdepth,angle,h,hcount,rfinal,rdepth,freq,lat,nofloq
        common/parm/q0,q0inv,q0sq,range,n0b,wi,winv
        common/rparm/rmax,steps,hstore,hlas
        common/sr/s1r,s2r,wron,s2rw
        common/loops/nloops,itmin,rfrac
        common/itime/itime,idate
        common/maxmin/rmax1,zmax,rzmax,zmin,rzmin,rtmax,ztmax,angmax
        common/lvsave/lvsave,time
        common/const/pi
        common/tau/tau1,tau0sq,tau0
        common/kv/kvsq,kv
        common/option/yfluct,ylong,yray2
        common/surfac/reflct
c
         save
c       data nofloq/.true. /
c      data sdepth,angle/1000.,0./
c      data h,hcount,rfinal,rdepth/25.,10,100000.,1000./
c      data freq,lat/100.,30./
c
          hstore=hcount*h
          call ssc0(c0)
          q0 = 2.*freq*pi/c0
          q0inv=1./q0
        q0sq=q0*q0
          wi=(1./12.)*sin(pi*lat/180.)
          wi=2.*pi*wi
c     print heading for ray
c
      if(ylong)call rheadr(sdepth,angle,rfinal,rdepth,h)
c
          rmax=rfinal
          if (nofloq) rmax=rmax+2.*h
          rmax1=rmax
c     list parameters of subroutines
         if(ylong) then
         call sslist
         call bflist
         call fllist(c0)
         endif
c
c     integrate the ray over one double loop or rfinal
c
        jtime0 = timeit()
      call dle(error)
        if(ylong) then
        jtime1 = timeit()
        jtime = jtime1 - jtime0
        write(iuout,9000) float(jtime)/60.
 9000   format(1x,'cpu sec elapsed to trace ray = ',g12.5,/)
        write(iuout,2000)
        endif
 2000   format('\f')
          hlas=amod(rmax,hstore)
c added lines to protect against hlas=0.0
          hmin=h/10.0
          if(hlas.eq.0.) hlas=hstore
          if(hlas.lt.hmin) then 
          hlas=hmin
          endif
c          nloops=(rfinal-0.1*h)/rmax
          nloops=rfinal/rmax
          rfrac=rfinal-nloops*rmax
          itmin=3.*alog(amax1(2.*nloops,8.))
c     print geometrical information
       if(ylong)call rgeom
c     print values of functions at maximum and minimum of ray
          call apxval
     *    (zmin,0.,wi,capx,dcapx,d2uapx,msapx,lpapx,lvapx,undef)
          lvsave=lvapx
          if (undef) go to 900
          if(ylong)call rextr(capx,dcapx,d2uapx,msapx,lvapx)
          if (error) go to 900
c     print miscellaneous functions at receiver
c set s1r=0.2*range for all functions except tl in recvr. 10/13/94.glr.
          call s(rfinal,s1r,s2r,sa,sb)
        s1rnew=0.2*rfinal*sign(1.0,s1r)
        call caustc
        call recvr
c        s1r=s1rnew
          wron=1./s1r
          s2rw= wron*s2r
        if(ylong) then
        jtime0 = timeit()
        jtime = jtime0-jtime1
        write(iuout,9002) float(jtime)/60.
 9002 format(1x,'cpu sec to calculate geometrical information = ',g12.5,
     */)
        call flush( iuout )
        endif
        call nngral(rfrac)
        call tcoef
        call ftt
        call fst
        call fss
        call gu
        if(ylong) then
        jtime1 = timeit()
        jtime=jtime1-jtime0
        write(iuout,9008) float(jtime)/60.
 9008 format(1x,'cpu sec to calculate tau integrals = ',g12.5,/)
        call flush( iuout )
        write(iuout,2000)
         endif
          call lphir
        if(ylong) then
        jtime0 = timeit()
        jtime = jtime0-jtime1
        write(iuout,9003) float(jtime)/60.
 9003 format(1x,'cpu sec to calculate wave region = ',g12.5,/)
        call flush( iuout )
        endif
          call spacsc
         if(ylong) then
        jtime1 = timeit()
        jtime = jtime1-jtime0
        write(iuout,9007) float(jtime)/60.
 9007 format(1x,'cpu sec to calculate space scales = ',g12.5,/)
        call flush( iuout )
        endif
          call freqsc
         if(ylong) then
        jtime0 = timeit()
        jtime= jtime0-jtime1
        write(iuout,9006) float(jtime)/60.
 9006 format(1x,'cpu sec to calculate frequency scales = ',g12.5,/)
        call flush( iuout )
        write(iuout,2000)
        endif
          call timesc
        if(ylong) then
        jtime1 = timeit()
        jtime=jtime1-jtime0
        write(iuout,9005) float(jtime)/60.
 9005 format(1x,'cpu sec to calculate time scales = ',g12.5,/)
        call flush( iuout )
        endif
          call path
        if(ylong) then
        jtime0 = timeit()
        jtime = jtime0 - jtime1
        write(iuout,9004) float(jtime)/60.
 9004 format(1x,'cpu sec to calculate validity of path integral= ',g12.5
    *,/)
        call flush( iuout )
        endif
        call gamma
        if(ylong) then
        jtime1 = timeit()
        jtime = jtime1-jtime0
          write(iuout,9001)float(jtime)/60.
 9001     format(1x,'cpu secs to calculate gamma = ',g12.5)
        call flush( iuout )
        endif
          return
 900      print *,'Error in rayini for angle=', angle
     *, ' undef=',undef,' error=',error
          error=.true.
          return
          end
