      subroutine recvr
c print out quantities at receiver
	double precision wron,s2rw
        integer steps,hcount
        logical nofloq
        logical ylong,yfluct,yray2
	real zdl(1000),tdl(1000),ttdl(1000),s2bdl(1000),bfdl(1000),
     *pwtdl(1000),psqidl(1000),pdwt(1000),pdidl(1000),
     *qkv(1000),qkvsq(1000),locn(4000),lat
	common/iounit/iuinp,iuout
      common/mpparm/sdepth,angle,h,hcount,rfinal,rdepth,freq,lat,nofloq
      common/rayst/zdl,tdl,ttdl,s2bdl,bfdl,pwtdl,psqidl,pdwt,pdidl
     *,qkv,qkvsq
	common/rparm/rmax,steps,hstore,hlas
	common/sr/s1r,s2r,wron,s2rw
	common/loops/nloops,itmin,rfrac
	common/ncaust/ncaust,locn
	common/recevr/timetr,tl,ata,angler,zrc
	common/const/pi
        common/tt/ttvl
        common/maxmin/rmax1,zmax,rzmax,zmin,rzmin,rtmax,ztmax,angmax
        common/option/yfluct,ylong,yray2
        common/case/nflag
c
c         print *,'in recvr,rfinal=',rfinal
          call sspeed(sdepth,c,dc,d2ur,undef)
          snellc=c/cos(angle*pi/180.)
          ta=terp(tdl,rfinal)
c receiver depth
          zrc=terp(zdl,rfinal)
c transmission loss
          tl=10.*alog10(abs(s1r*rfinal))
calculate travel time
	call wttvl
        timetr = ttvl
c calc of no. of caustics using no. of double loops
c         nturn=int((rfinal-rzmin)*2./rmax1)
c         ncaust=nturn-sign(s1x1,1.)*((1.+sign(s1r/abs(s1r),1.))/2.)
c
11        if(zrc.ge.0.0) go to 22
          zrc=-zrc
          ta=-ta
22        ata=atan(ta)
          if(nflag.gt.0) then
          rdepth=zrc
          angler=ata
          go to 24
          endif
          call sspeed(rdepth,c,dc,d2ur,undef)
          dtt=(rdepth-zrc)*sin(ata)/c
c travel time
          timetr=timetr-dtt
c angle at receiver
          angler=acos(c/snellc)
24          angler=sign(angler,ata)
          angler=angler*180./pi
          ata=ata*180./pi
          if(ylong) then
         nloopr=nloops
         rfracr=rfrac
         if(zmin.eq.0.0) then
         nloopr=nloops*2
         rmaxr=rmax1/2.0
         if(rfrac.ge.rmaxr) then
         nloopr=nloopr+1
         rfracr=rfrac-rmaxr
         endif
         endif
        write(iuout,9200) zrc,ata,timetr,nloops,itmin
c        write(iuout,9200) rdepth,angler,timetr,nloopr,itmin
	write(iuout,9300) ncaust,(locn(j),j = 1,ncaust)
	write(iuout,9400) rfracr,s1r,s2r,tl
        endif
 9200     format(' quantities at range of receiver:'//
     *    'ray depth                     ',g12.5,'m         '/
     *    'ray angle                     ',g12.5,'deg       '/
     *    'travel time                   ',g12.5,'sec       '/
     *    'number of loops               ',i3/
     *    'min number of iterations      ',i3)
 9300	format('caustics            locations (km)',
     */,i5,13x,6f9.1,/,(8f9.1,))
 9400	format(
     *    'rfrac=amod(rfinal,rmax)       ',g12.5,'m         '/
     *    's1                            ',g15.8,'          '/ 
     *    's2                            ',g15.8,'          '/
     *    'tl    transmission loss       ',g15.8,'          '/)
          return
          end
