	subroutine spacsc
c calculate kv squared
c and other coherence parameters from internal-wave effects
        logical yfluct,ylong,yray2
	real intl,kv,kvsq,logphi,lambda,lamphi,lmphsq,n0b
	common/iounit/iuinp,iuout
        common/loops/nloops,itmin,rfrac
        common/parm/q0,q0inv,q0sq,range,n0b,wi,winv
	common/lphi/phisq,phi,logphi,lambda,lamphi,lmphsq
	common/kv/kvsq,kv
        common/horiz/hseps,hsepr,wkhsq
        common/rms/th,thh
        common/option/yfluct,ylong,yray2
      call wkvsq
      kvsq = q0sq * kvsq
      kvsq = kvsq * logphi
      kv = sqrt(kvsq)
      th = 57.3*kv/q0
      call wkhsqs
      pkhsq=2.0*q0sq*wkhsq
      thh=57.3*sqrt(pkhsq)/(q0*hsepr)
 112  format(/'SPACE SCALES'/)
      if(ylong) then
      write(iuout,112)
      write(iuout,113) kv,1./kv,th
      write(iuout,115) pkhsq,thh
      endif
 113  format(
     *'vertical coherence wavenumber             = kv         = ',
     *g12.5,  '  1/m',/,
     *'vertical coherence length                 = 1/kv       = ',
     *g12.5,  '  m',/,
     *'rms vertical-angle spread                   = kv/q       = ',
     *g12.5,  '  deg',/)
 115  format(
     *'horizontal decorrelation                    = pkhsq      = ',
     *g12.5,' no units', /,
     *'rms horizontal-angle spread                 = thh        = ',
     *g12.5,  '  deg',/)
	return
	end
