      subroutine albet(ix,alpha,beta,wdens)
c find gammma by either case1 or case2
      real mj,jstar,logphi,na,msqmax,njinv
      common/flparm/na,jstar,zeta,gamad,msqmax,mj,njinv,avj
      integer flag2
	data eugam/.577215664902/
c
c test for error on alpha due to misinterpolation on wints
      if(alpha.le.0.) go to 67
      go to 2
c 1    write(6,9)ix,alpha
 9    format(1x,i4,g12.4)
      print *,'alpha less than 0 = error'
      go to 67
c 
2     betasq = beta * beta
      xjsq = jstar*jstar
c DECISIONS ON APPROPRIATE GAMMA FORMULA
      if(alpha.le.(1.e-03)) then
c CASE 4 
      flag2 = 0
      w = .25*betasq/alpha
      else if(alpha.le.(1.e-02)) then
c CASE 2(flag2's first digit is case and second digit is no. terms0
      flag2 = 23
      else if(alpha.le.(1.e-01)) then
      flag2 = 26
      else if(alpha.gt.(.1).and.alpha.le.(.13)) then
c CASE 1 CONDITIONS
      flag2 = 16
      else if(alpha.gt.(.13).and.alpha.le.(.2)) then
      flag2 = 15
      else if(alpha.gt.(.2).and.alpha.le.(.33)) then
      flag2 = 14
      else if(alpha.gt.(.33).and.alpha.le.(.64)) then
      flag2 = 13
      else if(alpha.gt.(.64).and.alpha.le.(5.)) then
      flag2 = 12
      else if(alpha.gt.(5.)) then
      flag2 = 11
      else
      print *,'Error : alpha outside of  accepted range',alpha
      stop
      end if
      if(flag2.gt.10.and.flag2.lt.20)  then
c DO CASE 1
        sum = 0.
        do 10 k=1,(flag2-10)
        fk=float(k)
        fksq=fk*fk
        afactr = fksq*alpha
c exp(-88.03) gives an erroroneous answer
c 88.02 was changed to 58.02 May 18.90.glr.
        if(afactr.gt.(58.02)) go to 20
        c1coef=fk*(xjsq+fksq)
        if(c1coef.eq.0.) print *,'error denominator = 0.'
        bfactr = fksq*beta
        if(bfactr.lt.(.01)) go to 90
        term = 1.-cos(bfactr)
        go to 91
c approx. to 1-cos(beta*jstar*jstar)
 90     term = .5*bfactr*bfactr
 91     term = term*exp(-afactr)/c1coef
        go to 30
 20     term = 0.
 30     sum = sum + term
 10     continue
        w = sum
      else  if(flag2.ge.20)  then
c DO CASE 2
        theta = atan(beta/alpha)
        a = alpha * xjsq
        b = beta * xjsq
        biga = sqrt(a * a + b * b)
 50     cb = cos(b)
        sib = sin(b)
        exa = exp(-a)
        wsum1 = (1.-exa)*alog(a)
        wsum2 = -(cb-exa)*alog(biga)
        wsum3 =  (1. - cb)*eugam 
        wsum4 = theta*sib
        sum = wsum1 + wsum2 + wsum3 + wsum4
        coef = 1.
        aterm =1.
        bgatrm =1.
        thetrm = 0.
        do 3 k = 1,(flag2-20)
        floatk = float(k)
        coef =  -coef/floatk
        coef2 = coef/floatk
        aterm=aterm*a
        bgatrm = bgatrm*biga
        thetrm = thetrm+theta
        thtrmb = thetrm + b
        wsumt =  coef2*(aterm - bgatrm*cos(thtrmb))
        sum = wsumt + sum
 3      continue
        w = (sum)/(2.*xjsq*exa)
        end if
        wdens = w
        return
 67     wdens=0.
         return
         end
