      subroutine lpofr(lp,xro,c,dc)
      double precision xro
      real n0b,n0bwi,lp,lat
      logical nofloq
      integer hcount
      common/const/pi
      common/parm/q0,q0inv,q0sq,range,n0b,wi,winv
      common/mpparm/sdepth,angle,h,hcount,rfinal,rdepth,freq,lat,nofloq
c     to approximate Lp(r,rho) by exponential
c LP  here is a function of the ray curvature radius r and rho=n*sin(theta)/wi
c as in S.M.Flatte and G.Rovner 'Path-integral expressions for fluctuations
c in acoustic transmission in the ocean waveguide',1997
      common/parlpa/alpc,sc,p,q,sa,qa,pa
      ro=abs(xro)
      r=320000.0
      if(dc.ne.0.0) r=abs(c/dc)
      if(r.gt.320000.0) r=320000.0
      ersc=0.0
      rscp=(r/sc)**p
      if(rscp.lt.40.) ersc=exp(-rscp)
      lp=alpc*(1.-ersc)**q/(1.+((ro/sa)**qa)*(r/sc)**pa)
       return
        entry lpinit
      averj=0.4001
      winv=12./sin(pi*lat/180.)
      n0bwi=n0b*winv
      alpc=(4./(pi*pi))*averj*n0bwi
      q=1.3
      p=0.5/q
        sc=20400.
        sa=3.5
        qa=2.0
        pa=0.5
      return
       end
