	subroutine caustc
c find (and store) locations of caustics of rays by looking for
c zeros of s1 which are between the sign changes of s1 (and we linearly
c interpolate between the opposite signed values).
c For this purpose s1 is computed from 0 to rfinal in 2.5 km steps.
c locn(50) stores the location of the caustics
	real locn(4000),lat
        integer hcount
        logical nofloq
	common/mpparm/sdepth,angle,h,hcount,rfinal,rdepth,freq,lat,nofloq
	common/ncaust/ncaust,locn
c
	n = rfinal/2500.
	ncaust = 0
	x = 0.
	call s(x,s1,s2,sar,sbr)
	s1old = 0.
	do 1 i = 1,n
	x = x+2500.
	call s(x,s1,s2,sar,sbr)
	if(s1*s1old.lt.0.) then
	ncaust = ncaust + 1
	locn(ncaust)  = (x + 2500. * s1old/(s1 - s1old))*1.e-03
	endif
	s1old = s1
 1	continue
	return
	end 
