	subroutine gamma
c Calculate gamma,related to the scintillation index
c read 'User's Guide to CAFI' about gamma.
c
      integer steps,hcount
      logical nofloq,yfluct,ylong,yray2
      double precision wron,s2rw
      real g1(900),g2(900),g3,g4(900),g5(900),g6(900),g7(900),
     & g8(900),g9(900),g10(900),g11(900)
      real ttf(900),stf(900),ssf(900)
      real wtsq(1000),wst(1000),wssq(1000)
      real logphi,lambda,lamphi,lmphsq,n0b
      real b12(900),a1b2(900),a2b1(900)
      real zdl(1000),tdl(1000),ttdl(1000),s2bdl(1000),bfdl(1000),
     & pwtdl(1000),psqidl(1000),pdwt(1000),pdidl(1000),qkv(1000),
     & qkvsq(1000)
      real dlama1(1000),dlama2(1000),dlama3(1000),dkvsq(1000)
     & ,dtt(1000),dnupsq(1000),dkhl(1000)
      real mj,lv,lp,musq,jstar,na,njinv,lat,msqmax
      common/flparm/na,jstar,zeta,gamad,msqmax,mj,njinv,avj
      common/rayst/zdl,tdl,ttdl,s2bdl,bfdl,pwtdl,psqidl,pdwt,pdidl,
     & qkv,qkvsq
      common/rayst2/dlama1,dlama2,dlama3,dkvsq,dtt,dnupsq,dkhl
      common/sr/s1r,s2r,wron,s2rw
      common/gam/gamj,gam
      common/lphi/phisq,phi,logphi,lambda,lamphi,lmphsq
      common/mpparm/sdepth,angle,h,hcount,rfinal,rdepth,freq,lat
     &,nofloq
      common/parm/q0,q0inv,q0sq,range,n0b,wi,winv
      common/iounit/iuinp,iuout
      common/ab12/a12,b12,a1b2,a2b1
      common/loops/nloops,itmin,rfrac
      common/rparm/rmax,steps,hstore,hlas
      common/wints/wtsq,wst,wssq,wtsq0p,wst0p,wssq0p,loc
      common/falpha/ttf,stf,ssf
      common/gcoef/g1,g2,g3,g4,g5,g6,g7,g8,g9,g10,g11
      common/option/yfluct,ylong,yray2
c      print *,'in gamma.f,loc=',loc
      call alphaf
      n1=nloops+1
      srmj=s1r/mj
      slphmj=srmj*s1r*logphi
      sum=0.0
      suml=0.0
      sum1=0.0
      if(nloops.eq.0) go to 44
      wtsqs=wtsq(steps)
      wsts=wst(steps)
      wssqs=wssq(steps)
      g3ss=g3*wssq(steps)
c      open(11,file='alphan')
c      rewind 11
      do 40 n=1,nloops
      g1t=g1(n)*2.0
      g4t=g4(n)*2.0
      g7st=g7(n)*2.0*wsts
      g9t=g9(n)*2.0
      g10t=g10(n)*2.0
      g11tt=g11(n)*wtsqs
      do 30 i=1,steps-2
      if(pwtdl(i).eq.0.) go to 30
      ttg=wst(i)*g1t+wtsq(i)*g2(n)+g3ss+
     & (wsts-wst(i))*g4t+(wtsqs-wtsq(i))*g5(n)
      fgtt=(ttf(n)+ttg)*s2bdl(i)**2
      stg=wssq(i)*g4(n)+wtsq(i)*g6(n)+(wssqs-wssq(i))*g1(n)
     & +g7st+(wtsqs-wtsq(i))*g8(n)
      fgst=(stf(n)+stg)*tdl(i)*s2bdl(i)
      ssg=wssq(i)*g5(n)+wst(i)*g9t
     & +(wssqs-wssq(i))*g2(n)+(wsts-wst(i))*g10t+g11tt
      fgss=(ssf(n)+ssg)*tdl(i)**2
      alpha=(fgtt+2.0*fgst+fgss)*dkvsq(i)/pwtdl(i)
      alpha=alpha*slphmj
c      if(alpha.lt.0.) print *,n,wtsq(i),wst(i),wssq(i),dkvsq(i),pwtdl(i)
      beta=a12*s2bdl(i)**2+(a1b2(n)+a2b1(n))*tdl(i)
     & *s2bdl(i)+b12(n)*tdl(i)**2
      beta=(srmj/q0)*beta*dkvsq(i)/pwtdl(i)
      call albet(i,alpha,beta,wdens)
c      x=(hstore*((steps-2)*(n-1)+i-1)+hlas*(n-1))
c      write(11,*) x/1000.,alpha,beta,wdens,wdens*pwtdl(i)*mj
      sum=sum+wdens*pwtdl(i)
30    continue
      i=steps-1
      if(pwtdl(i).eq.0.) go to 40
      ttg=wst(i)*g1t+wtsq(i)*g2(n)+g3ss+
     & (wsts-wst(i))*g4t+(wtsqs-wtsq(i))*g5(n)
      fgtt=(ttf(n)+ttg)*s2bdl(i)**2
      stg=wssq(i)*g4(n)+wtsq(i)*g6(n)+(wssqs-wssq(i))*g1(n)
     & +g7st+(wtsqs-wtsq(i))*g8(n)
      fgst=(stf(n)+stg)*tdl(i)*s2bdl(i)
      ssg=wssq(i)*g5(n)+wst(i)*g9t
     & +(wssqs-wssq(i))*g2(n)+(wsts-wst(i))*g10t+g11tt
      fgss=(ssf(n)+ssg)*tdl(i)**2
      alpha=(fgtt+2.0*fgst+fgss)*dkvsq(i)/pwtdl(i)
      alpha=alpha*slphmj
c      if(alpha.lt.0.) print *,n,wtsq(i),wst(i),wssq(i),dkvsq(i),pwtdl(i)
      beta=a12*s2bdl(i)**2+(a1b2(n)+a2b1(n))*tdl(i)
     & *s2bdl(i)+b12(n)*tdl(i)**2
      beta=(srmj/q0)*beta*dkvsq(i)/pwtdl(i)
      call albet(i,alpha,beta,wdens)
      suml=suml+wdens*pwtdl(i)
40    continue
      sum=sum*hstore
      suml=suml*hlas
44    n=nloops+1
      g3ss=g3*wssq0p
      g1t=g1(n)*2.0
      g4t=g4(n)*2.0
      g7st=g7(n)*2.0*wst0p
      g9t=g9(n)*2.0
      g10t=g10(n)*2.0
      g11tt=g11(n)*wtsq0p
      do 50 i=1,loc
      if(pwtdl(i).eq.0.) go to 50
      ttg=wst(i)*g1t+wtsq(i)*g2(n)+g3ss+
     & (wst0p-wst(i))*g4t+(wtsq0p-wtsq(i))*g5(n)
      fgtt=(ttf(n)+ttg)*s2bdl(i)**2
      stg=wssq(i)*g4(n)+wtsq(i)*g6(n)+(wssq0p-wssq(i))*g1(n)
     & +g7st+(wtsq0p-wtsq(i))*g8(n)
      fgst=(stf(n)+stg)*tdl(i)*s2bdl(i)
      ssg=wssq(i)*g5(n)+wst(i)*g9t
     & +(wssq0p-wssq(i))*g2(n)+(wst0p-wst(i))*g10t+g11tt
      fgss=(ssf(n)+ssg)*tdl(i)**2
      alpha=(fgtt+2.0*fgst+fgss)*dkvsq(i)/pwtdl(i)
      alpha=alpha*slphmj
      beta=a12*s2bdl(i)**2+(a1b2(n)+a2b1(n))*tdl(i)
     & *s2bdl(i)+b12(n)*tdl(i)**2
      beta=(srmj/q0)*beta*dkvsq(i)/pwtdl(i)
      call albet(i,alpha,beta,wdens)
      if(i.eq.loc) go to 50
      sum1=sum1+wdens*pwtdl(i)
50    continue
      sum1=sum1*hstore+wdens*pwtdl(loc)*(rfrac-hstore*(loc-1))
      gam = 2.*q0sq*mj*(sum+suml+sum1) 
c
      if(ylong) then
      write(iuout,114)
      write(iuout,115) gam
      endif
 114  format(/,'CORRECTION TO SCINTILLATION INDEX',/)
 115  format(
     */,
     *'full calculation',/,
     *'                   gamma = ',g12.5,/)
	return
	end
